---
name: Bug report
about: Report a bug to help us improve
title: 'Bug report'
labels: "Type: Bug"
---

**Bug description**
<A clear and concise description of the bug.>

**To Reproduce**
<Update the following list with your specific information.>
Steps to reproduce the behavior:
1. Compile with '...'
2. Run '...' case with '...' settings
3. Open '...' output
4. See the error

**Expected behavior**
<A clear and concise description of what you expected to happen.>

**Screenshots, if applicable**
<Add screenshots to help explain your problem.>

**OpenFAST Version**
<Please provide as much detail as possible including git commit. The best information is a screenshot of the OpenFAST system description that prints when running OpenFAST:>

```
**************************************************************************************************
 OpenFAST

 Copyright (C)  National Renewable Energy Laboratory
 Copyright (C)  Envision Energy USA LTD

 This program is licensed under Apache License Version 2.0 and comes with ABSOLUTELY NO WARRANTY.
 See the "LICENSE" file distributed with this software for details.
 **************************************************************************************************

 OpenFAST-v2.0.0
 Compile Info:
  - Architecture: 64 bit
  - Precision: double
  - Date: Nov 27 2018
  - Time: 17:19:38
 Execution Info:
  - Date: 11/29/2018
  - Time: 10:52:28-0700
```

**System Information (please complete the following information):**
 - OS: <e.g. Ubuntu 14.04 or macOS 10.12>
 - Compiler: <e.g. GFortran 4.4>
 - Compiler settings: <e.g. CMake flags or other settings>

**Additional context**
<Add any other context about the problem here.>